#ifndef _TEXT_MOD_PLUGIN_H_
#define _TEXT_MOD_PLUGIN_H_

#include <QtCore>
#include <QtCore/QObject>
#include <QtGui/QMenu>

#include <juffed/JuffPlugin.h>

class TextModPlugin : public QObject, public JuffPlugin {
Q_OBJECT
Q_INTERFACES(JuffPlugin)
public:
	TextModPlugin();
	virtual ~TextModPlugin();

	virtual QString name() const;
	virtual QString description() const;
	virtual QString targetEngine() const;

	virtual Juff::ActionList contextMenuActions() const;
	virtual QMenu* menu() const;

	virtual QToolBar* toolBar() const;

private slots:
	void toUpper();
	void toLower();
	void date();
	void htmlTemplate();
	void htmlTable();
	void htmlHref();
	void htmlImg();
	void htmlBold();
	void htmlItalic();
	void htmlUnderline();
	void htmlDiv();
	void htmlUList();
	void htmlOList();
	void callColorDlg();

private:
	void wrapSelectedText(const QString& fmt, int indent);
	void createList(bool numerated);
	
	QMenu* ctxMenu_;
	QMenu* menu_;
	QToolBar* toolBar_;
};

#endif
